datasource that can bind to PictureBox3D
Inheritance: GraphicsDataBase
Example #1
0
        /// <summary>
        /// create GraphicsData of given AnalyticalModel3D
        /// </summary>
        /// <param name="model">AnalyticalModel3D contains geometry data</param>
        /// <returns></returns>
        public static GraphicsData CreateGraphicsData(AnalyticalModel model)
        {
            IList <Curve> curveList = model.GetCurves(AnalyticalCurveType.ActiveCurves);

            if (curveList.Count > 0)
            {
                GraphicsData data = new GraphicsData();

                IEnumerator <Curve> curves = curveList.GetEnumerator();
                curves.Reset();
                while (curves.MoveNext())
                {
                    Curve curve = curves.Current as Curve;

                    try
                    {
                        List <XYZ> points = curve.Tessellate() as List <XYZ>;
                        data.InsertCurve(points);
                    }
                    catch
                    {
                    }
                }

                data.UpdataData();

                return(data);
            }
            else
            {
                throw new Exception("Can't get curves.");
            }
        }
Example #2
0
 /// <summary>
 /// constructor
 /// </summary>
 /// <param name="p"></param>
 /// <param name="graphicsData"></param>
 public InPlaceMembersForm(Properties p, GraphicsData graphicsData)
 {
     m_instanceProperties = p;
     m_graphicsData       = graphicsData;
     Application.AddMessageFilter(this);
     InitializeComponent();
 }
Example #3
0
 /// <summary>
 /// constructor 
 /// </summary>
 /// <param name="p"></param>
 /// <param name="graphicsData"></param>
 public InPlaceMembersForm(Properties p, GraphicsData graphicsData)
 {
     m_instanceProperties = p;
     m_graphicsData = graphicsData;
     Application.AddMessageFilter(this);
     InitializeComponent();
 }
Example #4
0
        /// <summary>
        /// create GraphicsData of given AnalyticalModel3D
        /// </summary>
        /// <param name="model">AnalyticalModel3D contains geometry data</param>
        /// <returns></returns>
        public static GraphicsData CreateGraphicsData(AnalyticalModel model)
        {
            IList<Curve> curveList = model.GetCurves(AnalyticalCurveType.ActiveCurves);

            if (curveList.Count > 0)
            {
                GraphicsData data = new GraphicsData();

                IEnumerator<Curve> curves = curveList.GetEnumerator();
                curves.Reset();
                while (curves.MoveNext())
                {
                    Curve curve = curves.Current as Curve;

                    try
                    {
                        List<XYZ> points = curve.Tessellate() as List<XYZ>;
                        data.InsertCurve(points);
                    }
                    catch
                    {
                    }
                }

                data.UpdataData();

                return data;
            }
            else
            {
                throw new Exception("Can't get curves.");
            }
        }
        /// <summary>
        /// create GraphicsData of given AnalyticalModel3D
        /// </summary>
        /// <param name="model">AnalyticalModel3D contains geometry data</param>
        /// <returns></returns>
        public static GraphicsData CreateGraphicsData(AnalyticalElement model)
        {
            IList <Curve> curveList = new List <Curve>();

            if (model is AnalyticalMember)
            {
                curveList.Add(model.GetCurve());
            }
            else if (model is AnalyticalPanel)
            {
                curveList = (model as AnalyticalPanel).GetOuterContour().ToList();
            }

            if (curveList.Count > 0)
            {
                GraphicsData data = new GraphicsData();

                IEnumerator <Curve> curves = curveList.GetEnumerator();
                curves.Reset();
                while (curves.MoveNext())
                {
                    Curve curve = curves.Current as Curve;

                    try
                    {
                        List <XYZ> points = curve.Tessellate() as List <XYZ>;
                        data.InsertCurve(points);
                    }
                    catch
                    {
                    }
                }

                data.UpdataData();

                return(data);
            }
            else
            {
                throw new Exception("Can't get curves.");
            }
        }
Example #6
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application
        /// which contains data related to the command,
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application
        /// which will be displayed if a failure or cancellation is returned by
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command.
        /// A result of Succeeded means that the API external method functioned as expected.
        /// Cancelled can be used to signify that the user cancelled the external operation
        /// at some point. Failure should be returned if the application is unable to proceed with
        /// the operation.</returns>
        public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData,
                                                ref string message, Autodesk.Revit.DB.ElementSet elements)
        {
            m_commandData = commandData;
            Transaction transaction = new Transaction(commandData.Application.ActiveUIDocument.Document, "External Tool");

            FamilyInstance inPlace = null;

            AnalyticalElement model = null;

            try
            {
                transaction.Start();
                if (!PrepareData(ref inPlace, ref model))
                {
                    message = "You should select only one in place member which have analytical model.";
                    return(Autodesk.Revit.UI.Result.Failed);
                }

                GraphicsData       graphicsData       = GraphicsDataFactory.CreateGraphicsData(model);
                Properties         instanceProperties = new Properties(inPlace);
                InPlaceMembersForm form = new InPlaceMembersForm(instanceProperties, graphicsData);
                if (form.ShowDialog() == System.Windows.Forms.DialogResult.Abort)
                {
                    return(Autodesk.Revit.UI.Result.Failed);
                }

                return(Autodesk.Revit.UI.Result.Succeeded);
            }
            catch (Exception e)
            {
                message = e.Message;
                return(Autodesk.Revit.UI.Result.Failed);
            }
            finally
            {
                transaction.Commit();
            }
        }